searchNodes=[{"doc":"Uinta is a plugin for the default Elixir logger that lowers log volume while maximizing log usefulness. It is not a logger backend, but rather includes Uinta.Formatter which will format logs on top of the default Elixir logger backend. In addition to the formatter, Uinta also includes Uinta.Plug . The plug is a drop-in replacement for Plug.Logger that will log out the request and response on a single line. It can also put the request info into the top-level JSON for easier parsing by your log aggregator. Installation The formatter and plug will be installed separately depending on the functionality that you want. To install the formatter, see the instructions in Uinta.Formatter To install the plug, see the instructions in Uinta.Plug","ref":"Uinta.html","title":"Uinta","type":"module"},{"doc":"The Uinta Formatter will wrap normal log statements in a JSON object. The log level, timestamp, and metadata will all be attached to it as parts of the object. The formatter can also format stuctured log messages. When a JSON string is received for formatting, it will be decoded and merged with the map to be output. In this way any keys that are passed to it will be on the high level object, so that they won't need to be extracted from a secondary object later on. JSON tends to be a great solution for making logs easily machine parseable, while still being mostly human readable. However, it is recommended that if you have separate configuration for development and production environments that you only enable this in the production environment as it can still decrease developer productivity to have to mentally parse JSON during development. Installation To use the formatter, you'll need to add it to your logger configuration. In your (production) config file, see if you have a line that looks something like this: config :logger , :console , format : &quot;[$level] $message \\n &quot; If you have it, you'll want to replace it with this: config :logger , :console , format : { Uinta.Formatter , :format } If you don't have it, you'll want to just add that line. Available Formatters Standard No special handling, outputs everything as JSON. Datadog Support adding Datadog specific metadata to logs.","ref":"Uinta.Formatter.html","title":"Uinta.Formatter","type":"module"},{"doc":"This function takes in four arguments, as defined by Logger : level is the log level, one of :debug , :info , :warn , and :error message is the message to be formatted. This should be iodata (typically String or iolist) timestamp is a timestamp formatted according to Logger.Formatter.time/0 metadata is a keyword list containing metadata that will be included with the log line However, this line should not be called manually. Instead it should be called by configuring the Elixir logger in your project to use it as a custom log formatter. See the installation instructions for more information. Delegates to Uinta.Formatter.Standard for backward compatibility","ref":"Uinta.Formatter.html#format/4","title":"Uinta.Formatter.format/4","type":"function"},{"doc":"Installation config :logger , :console , format : { Uinta.Formatter.Datadog , :format } Features Trace and Span id correlation Takes trace ids and span ids in the OpenTelemetry format (as hex) and convert them into Datadog format in the correct key. Logger.metadata must include the keys :trace_id and :span_id . Be sure to add those two keys onto the allowlist in the :logger config. See Datadog's documentation for more details. Example ctx = OpenTelemetry.Tracer . current_span_ctx ( ) Logger . metadata ( [ trace_id : OpenTelemetry.Span . hex_trace_id ( ctx ) , span_id : OpenTelemetry.Span . hex_span_id ( ctx ) ] )","ref":"Uinta.Formatter.Datadog.html","title":"Uinta.Formatter.Datadog","type":"module"},{"doc":"See Uinta.formatter.format/4","ref":"Uinta.Formatter.Datadog.html#format/4","title":"Uinta.Formatter.Datadog.format/4","type":"function"},{"doc":"No special handling, outputs everything as JSON. See Uinta.Formatter for more information.","ref":"Uinta.Formatter.Standard.html","title":"Uinta.Formatter.Standard","type":"module"},{"doc":"See Uinta.formatter.format/4","ref":"Uinta.Formatter.Standard.html#format/4","title":"Uinta.Formatter.Standard.format/4","type":"function"},{"doc":"","ref":"Uinta.Formatter.Standard.html#t:level/0","title":"Uinta.Formatter.Standard.level/0","type":"type"},{"doc":"","ref":"Uinta.Formatter.Standard.html#t:time/0","title":"Uinta.Formatter.Standard.time/0","type":"type"},{"doc":"Utilities for building a formatter","ref":"Uinta.Formatter.Util.html","title":"Uinta.Formatter.Util","type":"module"},{"doc":"Stringify as JSON","ref":"Uinta.Formatter.Util.html#encode/1","title":"Uinta.Formatter.Util.encode/1","type":"function"},{"doc":"Format as a map with metadata as a map, timestamp, level, and message.","ref":"Uinta.Formatter.Util.html#format/4","title":"Uinta.Formatter.Util.format/4","type":"function"},{"doc":"This plug combines the request and response logs into a single line. This brings many benefits including: Removing the need to visually match up the request and response makes it easier to read your logs and get a full picture of what has happened. Having a single line for both request and response halves the number of request logs that your log aggregator will need to process and index, which leads to saved costs In addition to combining the log lines, it also gives you the ability to output request logs in JSON format so that you can easily have your log aggregator parse the fields. To do this, pass json: true in the options when calling the plug. You will also gain the ability to not log certain paths that are requested, as long as those paths return a 200-level status code. This can be particularly useful for things like not showing health checks in your logs to cut down on noise. To do this, just pass ignored_paths: [&quot;/path_to_ignore&quot;] in the options. Finally, GraphQL requests will replace POST /graphql with the GraphQL operation type and name like QUERY getUser or MUTATION createUser if an operation name is provided. This will give you more visibility into your GraphQL requests without having to log out the entire request body or go into debug mode. If desired, the GraphQL variables can be included in the log line as well. The query can also be included if unnamed. Installation Installation of the plug will depend on how your app currently logs requests. Open YourApp.Endpoint and look for the following line: plug Plug.Logger If it exists in your endpoint, replace it with this (using the options you want): plug Uinta.Plug , log : :info , json : false , include_variables : false , ignored_paths : [ ] , filter_variables : [ ] , success_log_sampling_ratio : 1.0 , include_datadog_fields : false If your endpoint didn't call Plug.Logger , add the above line above the line that looks like this: plug Plug.RequestId Now you will also want to add the following anywhere in your main config file to make sure that you aren't logging each request twice: config :phoenix , logger : false Options :log - The log level at which this plug should log its request info. Default is :info :json - Whether or not this plug should log in JSON format. Default is false :ignored_paths - A list of paths that should not log requests. Default is [] . :include_variables - Whether or not to include any GraphQL variables in the log line when applicable. Default is false . :filter_variables - A list of variable names that should be filtered out from the logs. By default password , passwordConfirmation , idToken , and refreshToken will be filtered. :include_unnamed_queries - Whether or not to include the full query body for queries with no name supplied :success_log_sampling_ratio - What percentage of successful requests should be logged. Defaults to 1.0 :include_datadog_fields - Whether or not to add logger specific field based on Datadog logger. Default is false . See https://docs.datadoghq.com/logs/log_configuration/attributes_naming_convention/#http-requests for details","ref":"Uinta.Plug.html","title":"Uinta.Plug","type":"module"},{"doc":"","ref":"Uinta.Plug.html#client_ip/1","title":"Uinta.Plug.client_ip/1","type":"function"},{"doc":"","ref":"Uinta.Plug.html#t:format/0","title":"Uinta.Plug.format/0","type":"type"},{"doc":"","ref":"Uinta.Plug.html#t:graphql_info/0","title":"Uinta.Plug.graphql_info/0","type":"type"},{"doc":"","ref":"Uinta.Plug.html#t:opts/0","title":"Uinta.Plug.opts/0","type":"type"},{"doc":"","ref":"Uinta.Types.html","title":"Uinta.Types","type":"module"},{"doc":"","ref":"Uinta.Types.html#t:level/0","title":"Uinta.Types.level/0","type":"type"},{"doc":"","ref":"Uinta.Types.html#t:time/0","title":"Uinta.Types.time/0","type":"type"}]